package cn.com.tenlion.configtable.service.configtablefield;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.configtable.pojo.dtos.configtablefield.ConfigTableFieldDTO;
import cn.com.tenlion.configtable.pojo.vos.configtablefield.ConfigTableFieldVO;
import cn.com.tenlion.configtable.pojo.bos.configtablefield.ConfigTableFieldBO;
import cn.com.tenlion.configtable.pojo.pos.configtablefield.ConfigTableFieldPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IConfigTableFieldService
 * @Description: 
 * @Author: CodeFactory
 * @Date: 2021-06-24 11:06:57
 * @Version: 3.0
 **/
public interface IConfigTableFieldService {

    /**
     * 新增
     *
     * @param configTableFieldVO
     * @return
     */
    void save(ConfigTableFieldVO configTableFieldVO);

    /**
     * 新增
     *
     * @param token
     * @param configTableFieldVO
     * @return
     */
    void save(String token, ConfigTableFieldVO configTableFieldVO);

    /**
     * 新增
     *
     * @param configTableFieldVO
     * @return configTableFieldId
     */
    String saveReturnId(ConfigTableFieldVO configTableFieldVO);

    /**
     * 新增
     *
     * @param token
     * @param configTableFieldVO
     * @return configTableFieldId
     */
    String saveReturnId(String token, ConfigTableFieldVO configTableFieldVO);

    /**
     * 删除
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改
     *
     * @param configTableFieldId
     * @param configTableFieldVO
     * @return
     */
    void update(String configTableFieldId, ConfigTableFieldVO configTableFieldVO);

    /**
     * 修改
     *
     * @param token
     * @param configTableFieldId
     * @param configTableFieldVO
     * @return
     */
    void update(String token, String configTableFieldId, ConfigTableFieldVO configTableFieldVO);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigTableFieldDTO get(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configTableFieldId
     * @return
     */
    ConfigTableFieldDTO get(String configTableFieldId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigTableFieldBO getBO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configTableFieldId
     * @return
     */
    ConfigTableFieldBO getBO(String configTableFieldId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigTableFieldPO getPO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configTableFieldId
     * @return
     */
    ConfigTableFieldPO getPO(String configTableFieldId);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigTableFieldDTO> list(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigTableFieldBO> listBO(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigTableFieldPO> listPO(Map<String, Object> params);

    /**
     * 分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ConfigTableFieldDTO>> listPage(ListPage page);

    /**
     * 统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    List<ConfigTableFieldDTO> getByConfigTableId(String configTableId);

    /**
     * 更新布局排序
     * @param configTableId
     * @param createPage
     * @param jsonObject
     */
    void updateOrder(String configTableId, String createPage, JSONObject jsonObject);
}